/*4koma.c*/
#include<sys/bios.h>
#include<sys/libwwc.h>
#include<sys/fcntl.h>
#include<resource.h>
/*FONT*/
enum{PICT_PAT_ST=8,ETC_PAT_ST=8+20*15,TEXT_PAT_ST=8+28*15};
/*PALETTE*/
enum{PICT_PAL=0,TEXT_PAL=2,ETC_PAL};
/*KEY*/
enum{NT,ST,AA,BB,XU,XR,XD,XL,YU,YR,YD,YL};
/*DEFINE*/
#define ADR_CHAR 0
#define ADR_PALET ADR_CHAR+48
#define ADR_SCEN ADR_PALET+256
#define ADR_TEXT ADR_SCEN+448
#define SCR_W 28
#define SCR_H 18
#define PICT_L 4
#define PICT_T 0
#define PICT_W 20
#define PICT_H 15
#define TEXT_L 4
#define TEXT_T 15
#define TEXT_W 20
#define TEXT_H 3
#define ETC_L 24
#define ETC_T 0
#define ETC_W 4
#define ETC_H 18
#define PAL_MAX 4
#define COL_RGB 3
/*PROTOTYPE*/
void char_set(void);
void bkgd_set(void);
void palette_set(void);
int game_play(void);
void player_move(int);
void pict_set(void);
void text_set(int);
int key_get(void);
void p_set(void);
void p_reset(void);
void p_set_0(void);
void p_set_1(void);
void p_set_2(void);
void p_set_3(void);
void p_set_4(void);
void p_set_5(void);
void p_set_6(void);
void p_set_7(void);
void p_set_8(void);
void p_set_9(void);
void p_set_10(void);
void p_set_11(void);
void p_reset_0(void);
void p_reset_1(void);
void p_reset_2(void);
void p_reset_3(void);
void palet_set(int,int *);
void palet_fset(int,int *,int *);
/*GLOBAL*/
extern res_t far *_resource;
int Bcol[]={0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
int Wcol[]={0xf,0xf,0xf,0xf,0xf,0xf,0xf,0xf,0xf,0xf,0xf,0xf};
char Pdat[PICT_H][PICT_W][16];
int Amap[SCR_H][SCR_W],Argb[PAL_MAX*COL_RGB],Brgb[PAL_MAX*COL_RGB],Pn,Pa,Pv,Bv,Nl,Nr;
/*MAIN*/
void main(void)
{
	display_control(DCM_SCR1);
	text_set_screen(SCREEN1);
	text_screen_init();
	char_set();
	bkgd_set();
	palette_set();
	game_play();
}
void char_set(void)
{
	BYTE far *cpt;
	cpt=(BYTE far *)_resource+ADR_CHAR;
	font_set_colordata(ETC_PAT_ST,2,cpt+sizeof(res_image_t));
}
void bkgd_set(void)
{
	int *mpt,c,x,y;
	for(x=0,mpt=Amap[0];x<SCR_H*SCR_W;x++)
		*mpt++=0;
	for(y=c=0;y<PICT_H;y++)
		for(x=0;x<PICT_W;x++,c++)
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
	for(y=c=0;y<TEXT_H;y++)
		for(x=0;x<TEXT_W;x++,c++)
			Amap[TEXT_T+y][TEXT_L+x]=TEXT_PAL*0x0200|TEXT_PAT_ST+c;
	for(y=0;y<ETC_H;y++)
		for(x=0;x<ETC_W;x++)
			Amap[ETC_T+y][x]=Amap[ETC_T+y][ETC_L+x]=ETC_PAL*0x0200|ETC_PAT_ST+1;
	screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
}
void palette_set(void)
{
	if(wwc_get_hardarch()==HARDARCH_WSC)
	{
		wwc_set_color_mode(COLOR_MODE_4COLOR);
		wwc_palette_set_color(TEXT_PAL,0,0x0000);
		wwc_palette_set_color(TEXT_PAL,3,0x0fff);
	}
	else
		palette_set_color(ETC_PAL,0x00ca);
}
int game_play(void)
{
	int k;
	k=NT;
	Pv=0;
	player_move(0);
	while(k!=ST||Pn!=0)
	{
		while((k=key_get())==NT)
			;
		switch(k)
		{
			case XL:
				player_move(Nl);
				break;
			case XR:
				player_move(Nr);
				break;
		}
	}
}
void player_move(int pm)
{
	char far *spt;
	int tn,ec;
	spt=(BYTE far *)_resource+ADR_SCEN;
	spt=spt+spt[0]+pm*spt[1];
	Pn=*spt++<<8|*spt++;
	Pa=*spt++<<8|*spt++;
	ec=*spt++<<8|*spt++;
	Bv=*spt++<<8|*spt++;
	tn=*spt++<<8|*spt++;
	Nl=*spt++<<8|*spt++;
	Nr=*spt++<<8|*spt++;
	pict_set();
	if(wwc_get_hardarch()==HARDARCH_WSC)
		wwc_palette_set_color(ETC_PAL,1,ec);
	text_set(tn);
	Pv=Bv;
}
void pict_set(void)
{
	char far *ppt,*dpt;
	unsigned long m,n;
	int c,i,k,r;
	ppt=(BYTE far *)_resource+ADR_PALET;
	ppt=ppt+ppt[0]+Pn*ppt[1];
	for(i=r=0;i<PAL_MAX;i++)
	{
		c=*ppt++<<8|*ppt++;
		for(k=0;k<COL_RGB;k++)
			Argb[r++]=c>>(COL_RGB-1-k)*4&0xf;
	}
	if(Pn<16)
	{
		if((ppt=mmap("/rom0/km_pict_a.fr"))==NULL)
			bios_exit();
	}
	else
	{
		if((ppt=mmap("/rom0/km_pict_b.fr"))==NULL)
			bios_exit();
		Pn-=16;
	}
	ppt+=ppt[Pn*2]<<8|ppt[Pn*2+1];
	for(m=0,r=sizeof(res_image_t),dpt=**Pdat;m<PICT_H*PICT_W*16;)
	{
		c=*ppt++;
		i=c>>5&0x3;
		n=c&0x1f;
		while(i--)
			n=n<<8|*ppt++;
		if((c&0x80)==0)
			k=*ppt++;
		if(r>0)
		{
			if(r>n)
				i=n;
			else
				i=r;
			r-=i;
			n-=i;
			if(c&0x80)
				ppt+=i;
			if(n==0)
				continue;
		}
		m+=n;
		if(c&0x80)
			while(n--)
				*dpt++=*ppt++;
		else
			while(n--)
				*dpt++=k;
	}
	p_set();
	for(i=r=0;i<PAL_MAX;i++)
		for(k=0;k<COL_RGB;k++)
			Brgb[r]=Argb[r++];
}
void text_set(int n)
{
	char far *tpt;
	int c,i,j,x,y;
	tpt=(BYTE far *)_resource+ADR_TEXT;
	tpt=&tpt[tpt[2*n]<<8|tpt[2*n+1]];
	for(i=0,y=TEXT_T;i<TEXT_H;i++,y++)
		for(j=0,x=TEXT_L;j<TEXT_W;j++)
			text_put_char(x++,y,' ');
	for(i=0,y=TEXT_T;i<TEXT_H;i++,y++)
	{
		x=TEXT_L;
		while(c=*tpt++)
		{
			if(c>=0x80&&c<0xa0||c>=0xe0)
				c=c<<8|*tpt++;
			text_put_char(x++,y,c);
			sys_wait(1);
		}
	}
}
int key_get(void)
{
	int k,m,r;
	if(!(k=key_hit_check()))
		return NT;
	for(m=KEY_START,r=ST;!(k&m);m<<=1,r++)
		;
	return r;
}
void p_set(void)
{
	p_reset();
	palet_set(PICT_PAL,Argb);
	switch(Pa)
	{
		case 1:
			p_set_1();
			break;
		case 2:
			p_set_2();
			break;
		case 3:
			p_set_3();
			break;
		case 4:
			p_set_4();
			break;
		case 5:
			p_set_5();
			break;
		case 6:
			p_set_6();
			break;
		case 7:
			p_set_7();
			break;
		case 8:
			p_set_8();
			break;
		case 9:
			p_set_9();
			break;
		case 10:
			p_set_10();
			break;
		case 11:
			p_set_11();
			break;
		case 12:
			palet_set(PICT_PAL,Bcol);
			p_set_0();
			palet_fset(PICT_PAL,Bcol,Argb);
			break;
		case 13:
			palet_set(PICT_PAL,Wcol);
			p_set_0();
			palet_fset(PICT_PAL,Wcol,Argb);
			break;
		default:
			p_set_0();
			break;
	}
	if(wwc_get_hardarch()==HARDARCH_WSC)
		wwc_palette_set_color(ETC_PAL,0,0x0000);
	palet_set(PICT_PAL+1,Argb);
}
void p_reset(void)
{
	int c,x,y;
	switch(Pv)
	{
		case 1:
			p_reset_1();
			break;
		case 2:
			p_reset_2();
			break;
		case 3:
			p_reset_3();
			break;
		case 4:
			palet_fset(PICT_PAL,Brgb,Bcol);
			p_reset_0();
			break;
		case 5:
			palet_fset(PICT_PAL,Brgb,Wcol);
			if(wwc_get_hardarch()==HARDARCH_WSC)
				wwc_palette_set_color(ETC_PAL,0,0x0fff);
			p_reset_0();
			break;
		default:
			for(y=c=0;y<PICT_H;y++)
				for(x=0;x<PICT_W;x++,c++)
					Amap[PICT_T+y][PICT_L+x]=(PICT_PAL+1)*0x0200|PICT_PAT_ST+c;
			break;
	}
}
void p_set_0(void)
{
	int c,x,y;
	for(y=c=0;y<PICT_H;y++)
		for(x=0;x<PICT_W;x++,c++)
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
	font_set_colordata(PICT_PAT_ST,PICT_H*PICT_W,Pdat);
	screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
}
void p_set_1(void)
{
	int c,x,y;
	for(y=c=0;y<PICT_H;y++)
		for(x=0;x<PICT_W;x++,c++)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
}
void p_set_2(void)
{
	int c,x,y;
	for(x=0;x<PICT_W;x++)
		for(y=0,c=x;y<PICT_H;y++,c+=PICT_W)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
}
void p_set_3(void)
{
	int c,i,x,y,dx;
	for(i=0,x=(PICT_W-1)/2,dx=1;i<PICT_W;i++,x+=i*dx,dx*=-1)
		for(y=0,c=x;y<PICT_H;y++,c+=PICT_W)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
}
void p_set_4(void)
{
	int c,i,x,y,dy;
	for(i=0,y=(PICT_H-1)/2,dy=1;i<PICT_H;i++,y+=i*dy,dy*=-1)
		for(x=0,c=y*PICT_W;x<PICT_W;x++,c++)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
}
void p_set_5(void)
{
	int c,i,x,y,lx,ly;
	for(x=y=c=0,lx=PICT_W-1,ly=PICT_H-1;lx>0&&ly>0;lx-=2,ly-=2,x++,y++,c+=PICT_W+1)
	{
		for(i=0;i<lx;i++,x++,c++)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
		for(i=0;i<ly;i++,y++,c+=PICT_W)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
		for(i=0;i<lx;i++,x--,c--)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
		for(i=0;i<ly;i++,y--,c-=PICT_W)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
	}
	for(i=0;i<lx+1;i++,x++,c++)
	{
		Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
		font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
		screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
	}
}
void p_set_6(void)
{
	int c,i,x,y,lx,ly;
	for(x=PICT_H/2,y=(PICT_H-1)/2,c=(PICT_H-1)/2*PICT_W+PICT_H/2,lx=PICT_W-PICT_H/2*2,ly=1;x>0||y>0;lx++,ly++)
	{
		for(i=0;i<lx;i++,x++,c++)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
		for(i=0;i<ly;i++,y++,c+=PICT_W)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
		for(i=0,lx++;i<lx;i++,x--,c--)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
		for(i=0,ly++;i<ly;i++,y--,c-=PICT_W)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
	}
	for(i=0;i<lx;i++,x++,c++)
	{
		Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
		font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
		screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
	}
}
void p_set_7(void)
{
	int c,x,y;
	for(y=PICT_H-1;y>=0;y--)
	{
		c=y*PICT_W;
		font_set_colordata(PICT_PAT_ST+c,(PICT_H-y)*PICT_W,Pdat);
		for(x=0;x<PICT_W;x++,c++)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
	}
}
void p_set_8(void)
{
	int b,c,i,x,y,dx;
	for(i=0;i<2;i++)
		for(y=b=0,dx=i;y<PICT_H;y++,b+=PICT_W,dx^=1)
			for(x=dx,c=b+dx;x<PICT_W;x+=2,c+=2)
			{
				Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
				font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
				screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
			}
}
void p_set_9(void)
{
	int b,c,i,x,y,cx,cy;
	for(i=cx=cy=b=0;i<PICT_W+PICT_H-1;i++)
	{
		for(x=cx,y=cy,c=b;x>=0&&y<PICT_H;x--,y++,c+=PICT_W-1)
		{
			Amap[PICT_T+y][PICT_L+x]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
		if(i<PICT_W-1)
		{
			cx++;
			b++;
		}
		else
		{
			cy++;
			b+=PICT_W;
		}
	}
}
void p_set_10(void)
{
	int c,i,x,y;
	for(x=0;x<PICT_W;x++)
		for(y=0,c=x;y<PICT_H;y++,c+=PICT_W)
		{
			for(i=0;i<PICT_W-1;i++)
				Amap[PICT_T+y][PICT_L+i]=Amap[PICT_T+y][PICT_L+1+i];
			Amap[PICT_T+y][PICT_L+PICT_W-1]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
}
void p_set_11(void)
{
	int c,i,x,y;
	for(x=PICT_W-1;x>=0;x--)
		for(y=0,c=x;y<PICT_H;y++,c+=PICT_W)
		{
			for(i=PICT_W-1;i>0;i--)
				Amap[PICT_T+y][PICT_L+i]=Amap[PICT_T+y][PICT_L-1+i];
			Amap[PICT_T+y][PICT_L]=PICT_PAL*0x0200|PICT_PAT_ST+c;
			font_set_colordata(PICT_PAT_ST+c,1,&Pdat[y][x]);
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		}
}
void p_reset_0(void)
{
	int x,y;
	for(y=0;y<PICT_H;y++)
		for(x=0;x<PICT_W;x++)
			Amap[PICT_T+y][PICT_L+x]=ETC_PAL*0x0200|ETC_PAT_ST;
	screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
}
void p_reset_1(void)
{
	int i,j,k,x,y,dx;
	for(i=0,y=PICT_T,dx=1;i<PICT_H;i++,y++,dx^=1)
		for(j=0;j<PICT_W;j++)
		{
			if(dx)
				for(k=PICT_W-1,x=PICT_L+PICT_W-1;k>j;k--,x--)
					Amap[y][x]=Amap[y][x-1];
			else
				for(k=0,x=PICT_L;k<PICT_W-1-j;k++,x++)
					Amap[y][x]=Amap[y][x+1];
			Amap[y][x]=ETC_PAL*0x0200|ETC_PAT_ST;
			screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
			sys_wait(2);
		}
}
void p_reset_2(void)
{
	int i,j,k,x,y,dx;
	for(i=0;i<PICT_W;i++)
	{
		for(j=0,y=PICT_T,dx=1;j<PICT_H;j++,y++,dx^=1)
		{
			if(dx)
				for(k=PICT_W-1,x=PICT_L+PICT_W-1;k>i;k--,x--)
					Amap[y][x]=Amap[y][x-1];
			else
				for(k=0,x=PICT_L;k<PICT_W-1-i;k++,x++)
					Amap[y][x]=Amap[y][x+1];
			Amap[y][x]=ETC_PAL*0x0200|ETC_PAT_ST;
		}
		screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		sys_wait(3);
	}
}
void p_reset_3(void)
{
	int i,j,k,x,y;
	for(i=0;i<PICT_W/2+PICT_H-1;i++)
	{
		for(j=i-PICT_W/2+1>0?i-PICT_W/2+1:0,y=PICT_T+j;j<(i+1<PICT_H?i+1:PICT_H);j++,y++)
		{
			for(k=0,x=PICT_L;k<PICT_W/2-1-i+j;k++,x++)
				Amap[y][x]=Amap[y][x+1];
			Amap[y][x]=ETC_PAL*0x0200|ETC_PAT_ST;
			for(k=PICT_W-1,x=PICT_L+PICT_W-1;k>PICT_W/2+i-j;k--,x--)
				Amap[y][x]=Amap[y][x-1];
			Amap[y][x]=ETC_PAL*0x0200|ETC_PAT_ST;
		}
		screen_set_char(SCREEN1,0,0,SCR_W,SCR_H,Amap);
		sys_wait(3);
	}
}
void palet_set(int p,int *rgb)
{
	int c,i,j;
	if(wwc_get_hardarch()!=HARDARCH_WSC)
		return;
	for(i=0;i<PAL_MAX;i++)
	{
		for(j=c=0;j<COL_RGB;j++)
			c=c<<4|*rgb++;
		wwc_palette_set_color(p,i,c);
	}
}
void palet_fset(int p,int *rgb1,int *rgb2)
{
	int *apt,*bpt,a,b,c,i,j,k;
	if(wwc_get_hardarch()!=HARDARCH_WSC)
		return;
	for(i=0;i<16;i++)
	{
		for(j=0,apt=rgb1,bpt=rgb2;j<PAL_MAX;j++)
		{
			for(k=c=0;k<COL_RGB;k++)
			{
				a=*apt++;
				b=*bpt++;
				if(a<b)
					a=a+(b-a)*i/15;
				else
					a=b+(a-b)*(15-i)/15;
				c=c<<4|a;
			}
			wwc_palette_set_color(p,j,c);
		}
		sys_wait(4);
	}
}
